% psk31 signal generator

teststring='PSK31 signal from octave script. ';

% modulation frequency [Hz ]
fmod=1000;
% sample frequency of the system [Hz]
fs=20000;
% bit rate ( Baud [1/s])
baud=31.25;

% bits=[0 0 0 1 0 1 1 ]

preample	=[0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 ];
symbolSeparator	=[0 0];

% begin bit stream with preample
bits=preample;

% append charactes of teststring

for n=1:length(teststring),
	% append symbol separator
	bits=[ bits symbolSeparator];
	% append character bits
	bits=[ bits psk31_a2bits(teststring(n)) ];
end
bits=[ bits symbolSeparator];

%################################################################
% convert logical bitstream into differential phase bit stream
phase=1;
phase_bits(1)=phase; 

for n=1:length(bits),
	if bits(n)==0,
		phase=phase*-1;
	end	
	phase_bits(n+1)=phase;
end

% phases to to be transmitted
% phase_bits=[-1 1 -1 1];

bittime=1/baud;
sendtime=length(phase_bits)*bittime;

% samples n
n=1:sendtime*fs;

phases=[];

onephase_bitsamples=bittime*fs;

envelope=zeros(1,round(onephase_bitsamples/2));

% generate phase vektor
for bitcount=1:length(phase_bits)
  for kk=1:onephase_bitsamples     
	phases=[phases phase_bits(bitcount)];
  end
end

% generate signal without raised cosine envelopes
m=1:length(phases);
signal=sin(2*pi*fmod/fs.*m).*phases;

% generate envelopes
envelope=ones(1,length(phases));
for n=1:length(bits),
  for kk=1:onephase_bitsamples   
	if bits(n)==0,
		envelope(round((n-0.5)*onephase_bitsamples)+kk)=abs(cos(pi*baud/fs*(kk-1)));		
	end
  end
end

psk31_signal=envelope.*signal;

plot(psk31_signal);
grid on

% wavwrite(psk31_signal,fs,'psktest.wav');

